/* $Id:$ */
/**
 * @file   TArtFileDataSource.hh
 * @date   Created : Mar 29, 2008 16:29:03 JST
 *   Last Modified : 2008/10/30 20:09:46 JST
 * @author RIPS Taro <rips@entrance.ripsnet>
 *  
 *  
 *    Copyright (C)2008
 */
#ifndef TARTFILEDATASOURCEGZ_H
#define TARTFILEDATASOURCEGZ_H
#include "TArtDataSource.h"
#include <iostream>
#include <sys/stat.h>
#include <zlib.h>

using namespace std;

class TArtFileDataSourceGZ  : public TArtDataSource {
public:
   static TArtDataSource* Instance();
   ~TArtFileDataSourceGZ();
   int GetRunNumber(){return fRunNumber;}
   void SetRunNumber(int n){fRunNumber = n;}
   int Open(const char* sourceName = 0);
   void Close();
   int Read(char *buf, const int &size, const int &offset = 0);
   virtual int Seek(long offset, int origin);
protected:
   TArtFileDataSourceGZ();
private:
   static TArtDataSource *fgInstance;
   //FILE   *fFile;
   gzFile fFile;
   struct stat fFileStat;
   int fRunNumber;
};
#endif // end of #ifdef TARTFILEDATASOURCE_H
